/**************************************************************************/
/*                                                                        */
/*  Thibaut Balabonski, Sylvain Conchon, Jean-Christophe Filliâtre,       */
/*  Kim Nguyen, Laurent Sartre                                            */
/*                                                                        */
/*  Informatique - MP2I/MPI - CPGE 1re et 2e années.                      */
/*  Cours et exercices corrigés. Éditions Ellipses, 2022.                 */
/*                                                                        */
/*  https://www.informatique-mpi.fr/                                      */
/*                                                                        */
/**************************************************************************/

// composantes connexes d'un graphe non orienté

#include "prelude.h"
#include "graph.h"
#include "components.h"

// attention : ce code n'est pas réentrant à cause de nc
//   (bien sûr, on pourrait passer un pointeur sur nc, mais le code
//   deviendrait plus complexe à suivre)

int nc; // nombre total de composantes

void dfs(graph *g, int v, bool visited[], int num[]) {
  if (visited[v]) return;
  visited[v] = true;
  num[v] = nc;
  for (list *l = graph_succ(g, v); l != NULL; l = l->next)
    dfs(g, l->value, visited, num);
}

int components(graph *g, int num[]) {
  int n = graph_size(g);
  nc = 0;
  bool *visited = calloc(n, sizeof(bool));
  for (int i = 0; i < n; i++)
    visited[i] = false;
  for (int v = 0; v < n; v++) {
    if (visited[v]) continue;
    dfs(g, v, visited, num);
    nc++;
  }
  return nc;
}
